const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const stone_colors = sequelize.define(
    'stone_colors',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name_ar: {
        type: DataTypes.TEXT,
      
      

      },

hex: {
        type: DataTypes.TEXT,
      
      

      },

sort_order: {
        type: DataTypes.INTEGER,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  stone_colors.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity













    db.stone_colors.hasMany(db.stones, {
      as: 'stones_color',
      foreignKey: {
          name: 'colorId',
      },
      constraints: false,
    });


















//end loop





    db.stone_colors.hasMany(db.file, {
      as: 'swatch_image',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.stone_colors.getTableName(),
        belongsToColumn: 'swatch_image',
      },
    });


    db.stone_colors.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.stone_colors.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return stone_colors;
};


